"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("@builder.io/react");
var react_2 = require("react");
var Block_1 = require("./Block");
var defaultBlocks = [
    {
        '@type': '@builder.io/sdk:Element',
        responsiveStyles: {
            large: {
                marginTop: '20px',
                minWidth: '20px',
                overflow: 'hidden',
                fontSize: '0px',
            },
        },
        component: {
            name: 'Email:Image',
            options: {
                image: 'https://builder.io/api/v1/image/assets%2Fpwgjf0RoYWbdnJSbpBAjXNRMe9F2%2Ffb27a7c790324294af8be1c35fe30f4d',
            },
        },
    },
    {
        '@type': '@builder.io/sdk:Element',
        responsiveStyles: {
            large: {
                marginTop: '20px',
                textAlign: 'center',
            },
        },
        component: {
            name: 'Email:Text',
            options: {
                text: '<span>Enter some text...</span>',
            },
        },
    },
];
var Columns = /** @class */ (function (_super) {
    __extends(Columns, _super);
    function Columns() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Columns.prototype.render = function () {
        var _this = this;
        return (react_2.default.createElement(Block_1.Block, { attributes: this.props.attributes, builderBlock: this.props.builderBlock },
            this.props.stackColumnsAt && this.props.stackColumnsAt !== 'never' && (react_2.default.createElement("style", null, "\n          @media only screen and (max-width:" + (this.props.stackColumnsAt === 'mobile' ? 639 : 999) + "px) {\n            ." + this.props.builderBlock.id + "-separator-td {\n              display: none !important;\n            }\n\n            ." + this.props.builderBlock.id + "-subject-td {\n              display: block !important;\n              width: 100% !important;\n            }\n          }\n        ")),
            react_2.default.createElement("table", { style: { width: '100%' }, cellPadding: "0", cellSpacing: "0" },
                react_2.default.createElement("tbody", null,
                    react_2.default.createElement("tr", null, this.props.columns.map(function (col, index) { return (
                    // TODO: width
                    react_2.default.createElement(react_2.default.Fragment, { key: index },
                        index !== 0 && (react_2.default.createElement("td", { className: _this.props.builderBlock.id + "-separator-td", style: {
                                width: _this.props.space,
                                minWidth: _this.props.space,
                            } })),
                        react_2.default.createElement("td", { className: _this.props.builderBlock.id + "-subject-td", style: {
                                width: col.width,
                                verticalAlign: _this.props.verticalAlignContent || 'top',
                            } },
                            react_2.default.createElement(react_1.BuilderBlocks, { blocks: col.blocks, dataPath: "columns." + index + ".blocks", emailMode: true })))); }))))));
    };
    Columns = __decorate([
        react_1.BuilderBlock({
            name: 'Email:Columns',
            inputs: [
                {
                    name: 'columns',
                    type: 'array',
                    subFields: [
                        {
                            name: 'blocks',
                            type: 'uiBlocks',
                            hideFromUI: true,
                            defaultValue: defaultBlocks,
                        },
                        {
                            name: 'width',
                            type: 'string',
                            // defaultValue: 'auto',
                            // advanced: true,
                            helperText: 'Width, e.g. set to "100px" to always be 100 pixels wide, or "50%" to always fill 50% of the entire space',
                        },
                        {
                            name: 'verticalAlignContent',
                            type: 'string',
                            enum: ['top', 'bottom', 'middle'],
                            defaultValue: 'top',
                        },
                    ],
                    defaultValue: [
                        { blocks: defaultBlocks, width: '50%' },
                        { blocks: defaultBlocks, width: '50%' },
                    ],
                    onChange: function (options) {
                        var columns = options.get('columns');
                        var colsWithoutPx = columns.filter(function (col) {
                            var width = col.get('width') || '';
                            return !width.includes('px');
                        });
                        function round(num) {
                            return Math.round(num * 1000) / 1000;
                        }
                        function clearWidths() {
                            colsWithoutPx.forEach(function (col) {
                                // TODO: round
                                col.set('width', round(100 / colsWithoutPx.length) + '%');
                            });
                        }
                        if (Array.isArray(columns)) {
                            var containsColumnWithWidth = !!colsWithoutPx.find(function (col) { return col.get('width'); });
                            if (containsColumnWithWidth) {
                                var containsColumnWithoutWidth = !!colsWithoutPx.find(function (col) { return !col.get('width'); });
                                if (containsColumnWithoutWidth) {
                                    clearWidths();
                                }
                                else {
                                    var sumWidths = colsWithoutPx.reduce(function (memo, col) {
                                        return memo + col.get('width');
                                    }, 0);
                                    var widthsDontAddUp = sumWidths !== 100;
                                    if (widthsDontAddUp) {
                                        clearWidths();
                                    }
                                }
                            }
                        }
                    },
                },
                {
                    name: 'space',
                    friendlyName: 'Gap size',
                    type: 'number',
                    defaultValue: 20,
                    helperText: 'Size of gap between columns',
                },
                {
                    name: 'stackColumnsAt',
                    type: 'string',
                    defaultValue: 'mobile',
                    helperText: 'Convert horizontal columns to vertical at what device size',
                    enum: ['tablet', 'mobile', 'never'],
                },
            ],
        })
    ], Columns);
    return Columns;
}(react_2.default.Component));
exports.Columns = Columns;
//# sourceMappingURL=Columns.js.map