"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("@builder.io/react");
var react_2 = require("react");
var Block_1 = require("./Block");
var get_styles_1 = require("../functions/get-styles");
function updateQueryParam(uri, key, value) {
    if (uri === void 0) { uri = ''; }
    var re = new RegExp('([?&])' + key + '=.*?(&|$)', 'i');
    var separator = uri.indexOf('?') !== -1 ? '&' : '?';
    if (uri.match(re)) {
        return uri.replace(re, '$1' + key + '=' + encodeURIComponent(value) + '$2');
    }
    return uri + separator + key + '=' + encodeURIComponent(value);
}
exports.updateQueryParam = updateQueryParam;
var DEFAULT_ASPECT_RATIO = 0.7041;
var Image = /** @class */ (function (_super) {
    __extends(Image, _super);
    function Image() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Image.prototype.getSrcSet = function () {
        var url = this.props.image;
        if (!url) {
            return url;
        }
        var sizes = [100, 200, 400, 800, 1200, 1600, 2000];
        return sizes
            .map(function (size) { return updateQueryParam(url, 'width', String(size)) + " " + size + "w"; })
            .concat([url])
            .join(', ');
    };
    Image.prototype.render = function () {
        var allStyles = get_styles_1.getStyles(this.props.builderBlock) || {};
        var srcset = this.props.srcset;
        var image = this.props.image;
        if (srcset && image && image.includes('/api/v1/image')) {
            if (!srcset.includes(image.split('?')[0])) {
                console.debug('Removed given srcset');
                srcset = this.getSrcSet();
            }
        }
        else if (image) {
            srcset = this.getSrcSet();
        }
        return (react_2.default.createElement(Block_1.Block, { attributes: this.props.attributes, builderBlock: this.props.builderBlock },
            react_2.default.createElement("img", { key: react_1.Builder.isEditing
                    ? (typeof this.props.image === 'string' && this.props.image.split('?')[0]) ||
                        undefined
                    : undefined, alt: this.props.altText, height: this.props.height, width: this.props.width, role: !this.props.altText ? 'presentation' : undefined, style: {
                    height: allStyles.height || 'auto',
                    // maxWidth: '100%',
                    width: '100%',
                }, className: "builder-image", src: this.props.image, sizes: this.props.sizes, srcSet: srcset })));
    };
    Image = __decorate([
        react_1.BuilderBlock({
            name: 'Email:Image',
            image: 'https://firebasestorage.googleapis.com/v0/b/builder-3b0a2.appspot.com/o/images%2Fbaseline-insert_photo-24px.svg?alt=media&token=4e5d0ef4-f5e8-4e57-b3a9-38d63a9b9dc4',
            defaultStyles: {
                minHeight: '20px',
                minWidth: '20px',
                overflow: 'hidden',
                fontSize: '0px',
                textAlign: 'center',
            },
            inputs: [
                {
                    name: 'image',
                    type: 'file',
                    // TODO: gif!
                    allowedFileTypes: ['jpeg', 'jpg', 'png', 'svg'],
                    required: true,
                    // TODO: something better
                    defaultValue: 'https://builder.io/api/v1/image/assets%2Fpwgjf0RoYWbdnJSbpBAjXNRMe9F2%2Ffb27a7c790324294af8be1c35fe30f4d',
                    onChange: function (options) {
                        var DEFAULT_ASPECT_RATIO = 0.7041;
                        function loadImage(url, timeout) {
                            if (timeout === void 0) { timeout = 60000; }
                            return new Promise(function (resolve, reject) {
                                var img = document.createElement('img');
                                var loaded = false;
                                img.onload = function () {
                                    loaded = true;
                                    resolve(img);
                                };
                                img.addEventListener('error', function (event) {
                                    console.warn('Image load failed', event.error);
                                    reject(event.error);
                                });
                                img.src = url;
                                setTimeout(function () {
                                    if (!loaded) {
                                        reject(new Error('Image load timed out'));
                                    }
                                }, timeout);
                            });
                        }
                        function round(num) {
                            return Math.round(num * 1000) / 1000;
                        }
                        // // TODO
                        var value = options.get('image');
                        var aspectRatio = options.get('aspectRatio');
                        if (value && (!aspectRatio || aspectRatio === DEFAULT_ASPECT_RATIO)) {
                            return loadImage(value).then(function (img) {
                                var possiblyUpdatedAspectRatio = options.get('aspectRatio');
                                if (options.get('image') === value &&
                                    (!possiblyUpdatedAspectRatio || possiblyUpdatedAspectRatio === DEFAULT_ASPECT_RATIO)) {
                                    if (img.width && img.height) {
                                        // options.set('aspectRatio', round(img.height / img.width));
                                        options.set('height', img.height);
                                        options.set('width', img.width);
                                    }
                                }
                            });
                        }
                    },
                },
                {
                    name: 'altText',
                    type: 'string',
                    helperText: 'Text to display when the user has images off',
                },
                {
                    name: 'height',
                    type: 'number',
                    hideFromUI: true,
                },
                {
                    name: 'width',
                    type: 'number',
                    hideFromUI: true,
                },
                {
                    name: 'aspectRatio',
                    type: 'number',
                    helperText: "This is the ratio of height/width, e.g. set to 1.5 for a 300px wide and 200px tall photo. Set to 0 to not force the image to maintain it's aspect ratio",
                    advanced: true,
                    defaultValue: DEFAULT_ASPECT_RATIO,
                },
            ],
        })
    ], Image);
    return Image;
}(react_2.default.Component));
exports.Image = Image;
//# sourceMappingURL=Image.js.map