import { BuilderElement } from '@builder.io/react';
import React from 'react';
interface BlockProps {
    builderBlock: BuilderElement;
    attributes: any;
    innerStyleOverrides?: any;
}
declare type Size = 'large' | 'medium' | 'small' | 'xsmall';
export declare class Block extends React.Component<BlockProps> {
    outerTable: HTMLTableElement | null;
    getAlign(size: Size): "center" | "right" | "left";
    getVAlign(size: Size): "middle" | "bottom" | "top";
    getOuterStyles(size: Size): {
        width: string;
        border: string;
        display: string | undefined;
        verticalAlign: string | undefined;
    };
    getMidStyles(size: Size): {
        paddingTop: string | undefined;
        paddingRight: string | undefined;
        paddingBottom: string | undefined;
        paddingLeft: string | undefined;
        verticalAlign: string;
        width: string | undefined;
    };
    getInnerStyles(size: Size): any;
    getInnerTableStyles(size: Size): {
        width: string | undefined;
    };
    getLeftTdStyle(size: Size): {
        display: string | undefined;
    };
    getRightTdStyle(size: Size): {
        display: string | undefined;
    };
    get css(): string;
    get bgImageUrl(): string | undefined;
    render(): JSX.Element;
}
export {};
