"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resetStyles = "\n/* Based on The MailChimp Reset INLINE: Yes. */\n\n/* Client-specific Styles */\n/* Force Outlook to provide a \"view in browser\" menu link. */\n#outlook a {\n    padding:0;\n}\n\na {\n    text-decoration: none;\n    color: inherit;\n}\n\nbody {\n    width:100% !important;\n    -webkit-text-size-adjust:100%;\n    -ms-text-size-adjust:100%;\n    margin:0;\n    padding:0;\n}\n\n/* Prevent Webkit and Windows Mobile platforms from changing default font sizes.*/\n/* Force Hotmail to display emails at full width */\n.ExternalClass {\n    width:100%;\n}\n.ExternalClass,\n.ExternalClass p,\n.ExternalClass span,\n.ExternalClass font,\n.ExternalClass td,\n.ExternalClass div {\n    line-height: 100%;\n}\n\n/* Forces Hotmail to display normal line spacing.  More on that: http://www.emailonacid.com/forum/viewthread/43/ */\n#backgroundTable {\n    margin:0;\n    padding:0;\n    width:100% !important;\n    line-height: 100% !important;\n}\n\n/* End reset */\n\n/* Some sensible defaults for images Bring inline: Yes. */\nimg {\n    outline:none;\n    text-decoration:none;\n    -ms-interpolation-mode: bicubic;\n}\n\na img {\n    border:none;\n}\n\n.image_fix {\n    display:block;\n}\n\n/* Yahoo paragraph fix Bring inline: Yes. */\np {\n    /* margin: 1em 0;*/\n    margin: 0;\n}\n\n/* Hotmail header color reset Bring inline: Yes. */\nh1, h2, h3, h4, h5, h6 {\n    color: black !important;\n}\n\nh1 a, h2 a, h3 a, h4 a, h5 a, h6 a {\n    color: blue !important;\n}\n\n/* Preferably not the same color as the normal header link color.  There is limited support for psuedo classes in email clients, this was added just for good measure. */\nh1 a:active,\nh2 a:active,\nh3 a:active,\nh4 a:active,\nh5 a:active,\nh6 a:active {\n    color: red !important;\n}\n\n/* Preferably not the same color as the normal header link color. There is limited support for psuedo classes in email clients, this was added just for good measure. */\nh1 a:visited,\nh2 a:visited,\nh3 a:visited,\nh4 a:visited,\nh5 a:visited,\nh6 a:visited {\n    color: purple !important;\n}\n\n/* Outlook 07, 10 Padding issue fix Bring inline: No.*/\ntable td {\n    border-collapse: collapse;\n}\n\n/* Remove spacing around Outlook 07, 10 tables Bring inline: Yes */\ntable {\n    border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;\n}\n\n/* Styling your links has become much simpler with the new Yahoo.  In fact, it falls in line with the main credo of styling in email and make sure to bring your styles inline.  Your link colors will be uniform across clients when brought inline. Bring inline: Yes. */\na {\n    color: orange;\n}\n\n\n/***************************************************\n ****************************************************\n MOBILE TARGETING\n ****************************************************\n ***************************************************/\n @media only screen and (max-device-width: 480px) {\n     /* Part one of controlling phone number linking for mobile. */\n a[href^=\"tel\"], a[href^=\"sms\"] {\n     text-decoration: none;\n     color: blue; /* or whatever your want */\n     pointer-events: none;\n     cursor: default;\n }\n\n .mobile_link a[href^=\"tel\"], .mobile_link a[href^=\"sms\"] {\n     text-decoration: default;\n     color: orange !important;\n     pointer-events: auto;\n     cursor: default;\n }\n\n }\n\n /* More Specific Targeting */\n\n @media only screen and (min-device-width: 768px) and (max-device-width: 1024px) {\n /* You guessed it, ipad (tablets, smaller screens, etc) */\n     /* repeating for the ipad */\n     a[href^=\"tel\"], a[href^=\"sms\"] {\n                 text-decoration: none;\n                 color: blue; /* or whatever your want */\n                 pointer-events: none;\n                 cursor: default;\n             }\n\n .mobile_link a[href^=\"tel\"], .mobile_link a[href^=\"sms\"] {\n             text-decoration: default;\n             color: orange !important;\n             pointer-events: auto;\n             cursor: default;\n         }\n }\n\n @media only screen and (-webkit-min-device-pixel-ratio: 2) {\n /* iPhone 4g styles in here */\n }\n\n /* Android targeting */\n @media only screen and (-webkit-device-pixel-ratio:.75){\n /* CSS for low density (ldpi) Android layouts in here */\n }\n @media only screen and (-webkit-device-pixel-ratio:1){\n /* CSS for medium density (mdpi) Android layouts in here */\n }\n @media only screen and (-webkit-device-pixel-ratio:1.5){\n /* CSS for high density (hdpi) Android layouts in here */\n }\n /* end Android targeting */\n\n";
//# sourceMappingURL=reset-styles.js.map